/*
 * @Description: 
 * @Author: wujc
 * @Date: 2021-09-02
 * @LastEditors: wujc
 * @LastEditTime: 2021-09-02
 */
var app = angular.module("AgentApp", ['ngCookies']);
var currentLanguage = 'en';
var currentUser = '';

app.factory('lanService', function($cookies) {
    if($cookies.get('lan')) {
        currentLanguage = $cookies.get('lan');
    }else {
        var lang = getUrlParam('lang');
        if(lang) {
            localStorage.setItem('lang', lang);
        }
        currentLanguage = localStorage.getItem('lang') ? localStorage.getItem('lang') : 'en';
    }
    if($cookies.get('username')) currentUser = $cookies.get('username');
    
    return {
        setCurrentLanguage: function(newCurrentLanguage) { currentLanguage = newCurrentLanguage },
        getCurrentLanguage: function() { return currentLanguage },
        lan: function(label, parameters) {
            if (currentLanguage == "cn") return cn()[label];
            else if (currentLanguage == "tc") return tc()[label];
            else if (currentLanguage == "tu") return tu()[label];
            else if (currentLanguage == "ru") return ru()[label];
            else return en()[label];
        }
    };
});

app.filter('lan', ['lanService', function(lanService) {
    return function(label) { return lanService.lan(label) };
}]);

app.controller('lanCtrl', function($scope, $http, $cookies, lanService) {
    $scope.language = lanService.getCurrentLanguage();
    $scope.changeLan = function(val) {
        $cookies.put('lan', val);
        $scope.language = val;
        lanService.setCurrentLanguage(val);
        window.location.reload();
    }
});

function lan(label) {
    if (currentLanguage == "cn") return cn()[label];
    else if (currentLanguage == "tc") return tc()[label];
    else if (currentLanguage == "tu") return tu()[label];
    else if (currentLanguage == "ru") return ru()[label];
    else return en()[label];
}

function getUrlParam(params) {
    // 通过window.location对象拿到url上?后的参数
    // substring() 方法用于提取字符串中介于两个指定下标之间的字符 有开始无结尾就是从1开始到末尾的所有
    var query = window.location.search.substring(1);
    // 通过&开始分隔
    var vars = query.split('&');
    // 对vars数组中的每个字符串通过&分隔
    for(var i = 0; i < vars.length; i++) {
        var index = vars[i].indexOf('=');
        var pair1 = vars[i].substring(0, index);
        var pair2 = vars[i].substring(index + 1);
        // 分割完之后得到的数组进行判断，拿到需要的参数
        if(pair1 == params) return pair2;
    }
    // 如果循环结束都没有需要的参数就返回false
    return false;
}

function asyncLoad(url) {
    var node = document.createElement('script');
    node.type = 'text/javascript';
    // node.async = true; // 使用async, 请根据实际需要修改
    node.defer = true; // 使用defer, 请根据实际需要修改
    node.src = url;
    document.getElementsByTagName('head')[0].appendChild(node);
}


app.controller("loginCtrl", function() {
    $(document).ready(function() {
        gatespace.ctrl().loginctrl().startctrl();
    });
});

app.controller("indexCtrl", function() {
    $(document).ready(function() {
        gatespace.ctrl().indexctrl().startctrl();
    });
})

app.controller("summaryCtrl", function() {
    $(document).ready(function() {
        gatespace.ctrl().summaryctrl().startctrl();
    });
});

app.controller("historyCtrl", function() {
    $(document).ready(function() {
        gatespace.ctrl().historyctrl().startctrl();
    });
});
app.controller("readFileCtrl", function() {
    $(document).ready(function() {
        startReadFileCtrl();
    });
});

app.controller("dischargeCtrl", function() {
    $(document).ready(function() {
        gatespace.ctrl().dischargectrl().startctrl();
    });
});

app.controller("faultCtrl", function() {
    $(document).ready(function() {
        gatespace.ctrl().faultctrl().startctrl();
    });
});

app.controller("alarmRealCtrl", function() {
    $(document).ready(function() {
        gatespace.ctrl().alarmrealctrl().startctrl();
    });
});

app.controller("alarmCtrl", function() {
    $(document).ready(function() {
        gatespace.ctrl().alarmctrl().startctrl();
    });
});

app.controller("networkCtrl", function() {
    $(document).ready(function() {
        gatespace.ctrl().networkctrl().startctrl();
    });
});

app.controller("serialPortCtrl", function() {
    $(document).ready(function() {
        gatespace.ctrl().serialportctrl().startctrl();
    });
});

app.controller("alarmSetupCtrl", function() {
    $(document).ready(function() {
        gatespace.ctrl().alarmsetupctrl().startctrl();
    });
});

app.controller("groupSetupCtrl", function() {
    $(document).ready(function() {
        gatespace.ctrl().groupsetupctrl().startctrl();
    });
});

app.controller("functionSetupCtrl", function() {
    $(document).ready(function() {
        gatespace.ctrl().functionsetupctrl().startctrl();
    });
});

app.controller("timerSetupCtrl", function() {
    $(document).ready(function() {
        gatespace.ctrl().timersetupctrl().startctrl();
    });
});

app.controller("userManagerCtrl", function() {
    $(document).ready(function() {
        gatespace.ctrl().usermanagerctrl().startctrl();
    });
});

app.controller("upgradeCtrl", function() {
    $(document).ready(function() {
        gatespace.ctrl().upgradectrl().startctrl();
    });
});

app.controller("emailSetupCtrl", function() {
    $(document).ready(function() {
        gatespace.ctrl().emailctrl().startctrl();
    });
});

app.controller("projectDetailCtrl", function() {
    $(document).ready(function() {
        gatespace.ctrl().projectdetailctrl().startctrl();
    });
});

app.controller("projectBatteryCtrl", function() {
    $(document).ready(function() {
        gatespace.ctrl().projectbatteryctrl().startctrl();
    });
});

app.controller("projectBackupCtrl", function() {
    $(document).ready(function() {
        gatespace.ctrl().projectbackupctrl().startctrl();
    });
});

app.controller("deviceConnectionCtrl", function() {
    $(document).ready(function() {
        gatespace.ctrl().deviceconnectionctrl().startctrl();
    });
});

app.controller("customProjectCtrl", function() {
    $(document).ready(function() {
        gatespace.ctrl().customprojectctrl().startctrl();
    });
});

app.controller("superConfigCtrl", function() {
    $(document).ready(function() {
        gatespace.ctrl().superconfigctrl().startctrl();
    });
});


// 为了 ie8 解析date方法
// whatever date or datetime the format must be '2012-08-16 14:16:58'
function parseDate(str) {
    var date = new Date();
    // var date = Date.parse(str);
    // return date;
    // only date
    if (str.length < 11) {
        // 2012-9-01
        /*if(str.length==9){
            date.setFullYear(str.substring(0,4), str.substring(5,6)-1, str.substring(7,9));
            date.setHours(0, 0, 0, 0);
        }else{
            date.setFullYear(str.substring(0,4), str.substring(5,7)-1, str.substring(8,10));
            date.setHours(0, 0, 0, 0);
        }
        return date;*/
        return Date.UTC(str.substring(0, 4), str.substring(5, 7) - 1, str.substring(8, 10), 0, 0, 0);
    } else {
        /*date.setFullYear(str.substring(0,4), str.substring(5,7)-1, str.substring(8,10));
        date.setHours(str.substring(11,13), str.substring(14,16), str.substring(17,19), 000);
        return date;*/
        return Date.UTC(str.substring(0, 4), str.substring(5, 7) - 1, str.substring(8, 10), str.substring(11, 13), str.substring(14, 16), str.substring(17, 19));
    }
}

function dateFormat(date) {
    if (date == null || date == 0) {
        return;
    }
    var month = (date.getMonth() + 1) + "";
    if (month.length == 1) {
        month = "0" + month;
    }
    var day = date.getDate() + "";
    if (day.length == 1) {
        day = "0" + day;
    }
    return date.getFullYear() + "-" + month + "-" + day;
}

function toRound(x) {
    if (x == null) {
        return "N/A";
    }
    var f = parseFloat(x);
    //if (isNaN(f)||f>1E9) {
    if (isNaN(f)) {
        return "N/A";
    }
    f = Math.round(x);
    return f;
}

function hWhRound(x) {
    if (x == null) {
        return "N/A";
    }
    var f = parseFloat(x);
    //if (isNaN(f)||f>=4E10) {
    if (isNaN(f)) {
        return "N/A";
    }
    f = Math.round(x);
    return f;
}

function chartkWhRound(x) {
    if (x == null) {
        return null;
    }
    var f = parseFloat(x);
    //if (isNaN(f)||f>=4E10) {
    if (isNaN(f)) {
        return null;
    }
    f = Math.round(x);
    return f;
}
// 保留1位小数
function toDecimal1(x) {
    if (x == null) {
        return "N/A";
    }
    var f = parseFloat(x);
    //if (isNaN(f)||f>1E9) {
    if (isNaN(f)) {
        return "N/A";
    }
    f = Math.round(x * 10) / 10;
    return f;
}
// 保留2位小数
function toDecimal2(x) {
    if (x == null) {
        return "N/A";
    }
    var f = parseFloat(x);
    //if (isNaN(f)||f>1E9) {
    if (isNaN(f)) {
        return "N/A";
    }
    f = Math.round(x * 100) / 100;
    return f;
}
//数据后加N/A
function toAddKW(x) {
    if (x == null) {
        return "N/A";
    }
    return x + " KW";
}
//数据后加%
function toAddPercent(x) {
    if (x == null) {
        return "N/A";
    }
    if (x == 'null') {
        return "N/A";
    }
    return x + " %";
}
// 保留3位小数
function toDecimal3(x) {
    if (x == null) {
        return "N/A";
    }
    var f = parseFloat(x);
    //if (isNaN(f)||f>1E9) {
    if (isNaN(f)) {
        return "N/A";
    }
    f = Math.round(x * 1000) / 1000;
    return f;
}

function chartRound(x) {
    if (x == null) {
        return null;
    }
    var f = parseFloat(x);
    //if (isNaN(f)||f>1E9) {
    if (isNaN(f)) {
        return null;
    }
    f = Math.round(x);
    return f;
}
//保留1位小数
function chartDecimal1(x) {
    if (x == null) {
        return null;
    }
    var f = parseFloat(x);
    //if (isNaN(f)||f>1E9) {
    if (isNaN(f)) {
        return null;
    }
    f = Math.round(x * 10) / 10;
    return f;
}
// 保留2位小数
function chartDecimal2(x) {
    if (x == null) {
        return null;
    }
    var f = parseFloat(x);
    //if (isNaN(f)||f>1E9) {
    if (isNaN(f)) {
        return null;
    }
    f = Math.round(x * 100) / 100;
    return f;
}
// 保留3位小数
function chartDecimal3(x) {
    if (x == null) {
        return null;
    }
    var f = parseFloat(x);
    //if (isNaN(f)||f>1E9) {
    if (isNaN(f)) {
        return null;
    }
    f = Math.round(x * 1000) / 1000;
    return f;
}

// 是否为润年
function IsLeapYear(nYear) {
    // 能被400整除
    if (0 == (nYear % 400)) {
        return 1;
    }

    // 能被4整除，但不能被100整除
    if (0 == (nYear % 4) && (0 != nYear % 100)) {
        return 1;
    }

    return 0;
}

// 获取每月的天数
function GetMonthDays(nYear, nMonth) {
    var nDays = 0;

    switch (parseInt(nMonth)) {
        case 1:
        case 3:
        case 5:
        case 7:
        case 8:
        case 10:
        case 12:
            nDays = 31;
            break;

        case 2:
            if (IsLeapYear(nYear) == 1) {
                nDays = 29;
            } else {
                nDays = 28;
            }
            break;

        case 4:
        case 6:
        case 9:
        case 11:
            nDays = 30;
            break;

        default:
            nDays = 31;
            break;
    }

    return nDays;
}


//判断相差几天
function getCompareDays(strDateStart, strDateEnd) {
    var strSeparator = "-"; //日期分隔符
    var oDate1;
    var oDate2;
    var iDays;
    oDate1 = strDateStart.split(strSeparator);
    oDate2 = strDateEnd.split(strSeparator);
    var strDateS = new Date(oDate1[0], parseInt(oDate1[1]) - 1, oDate1[2]);
    var strDateE = new Date(oDate2[0], parseInt(oDate2[1]) - 1, oDate2[2]);
    iDays = parseInt(Math.abs(strDateS - strDateE) / 1000 / 60 / 60 / 24) //把相差的毫秒数转换为天数
    return iDays;
}

//判断是否在同一年
function IsSameYear(strDateStart, strDateEnd) {
    var strSeparator = "-"; //日期分隔符
    var oDate1;
    var oDate2;
    oDate1 = strDateStart.split(strSeparator);
    oDate2 = strDateEnd.split(strSeparator);

    if (oDate1[0] == oDate2[0]) {
        return true;
    } else {
        return false;
    }
}

//判断是否在同一月
function IsSameMonth(strDateStart, strDateEnd) {
    var strSeparator = "-"; //日期分隔符
    var oDate1;
    var oDate2;
    oDate1 = strDateStart.split(strSeparator);
    oDate2 = strDateEnd.split(strSeparator);

    if (oDate1[1] == oDate2[1]) {
        return true;
    } else {
        return false;
    }
}

//检测IP是否正确
function checkIP(obj) {
    $(obj).removeClass("wrongShow");
    var txt = $(obj).val();
    var regExp = /^(\d{1,3})\.(\d{1,3})\.(\d{1,3})\.(\d{1,3})$/;
    if ("" == txt.trim()) {
        //$(obj).val("");
        //return false;
        $(obj).addClass("wrongShow");
        layer.alert(lan('Promt_IPEmpty'), { title: [lan('Title'), true], btn: [lan('OK')] });
        return true;
    }
    if (!regExp.test(txt)) {
        $(obj).addClass("wrongShow");
        layer.alert(lan('Promt_IPError'), { title: [lan('Title'), true], btn: [lan('OK')] });
        return true;
    }
    return false;
}

//检测IP是否在同一网段
function checkSameIP(obj1, obj2) {
    $(obj1).removeClass("wrongShow");
    $(obj2).removeClass("wrongShow");
    var addr1 = $(obj1).val().split(".");
    var addr2 = $(obj2).val().split(".");
    var temp1 = new Array();
    var temp2 = new Array();
    for (var i = 0; i < addr1.length - 1; i++) {
        temp1.push(addr1[i]);
    }

    for (var i = 0; i < addr2.length - 1; i++) {
        temp2.push(addr2[i]);
    }

    if (temp1.join(".") == temp2.join(".")) {
        $(obj1).addClass("wrongShow");
        $(obj2).addClass("wrongShow");
        layer.alert(lan('Promt_IPEqual'), { title: [lan('Title'), true], btn: [lan('OK')] });
        return true;
    }

    return false;
}

//检测电话号码
function checkTel(obj) {
    $(obj).removeClass("wrongShow");
    var txt = $(obj).val();
    var regExp = /^[0-9 \-\+]+$/;
    if ("" == txt.trim()) {
        $(obj).val("");
        return false;
    }
    if (!regExp.test(txt)) {
        $(obj).addClass("wrongShow");
        layer.alert(lan('Promt_TelError'), { title: [lan('Title'), true], btn: [lan('OK')] });
        return true;
    }
    return false;
}

// 支持小数
function onlyNumber(obj) {
    $(obj).removeClass("wrongShow");
    var txt = $(obj).val();
    var regExp = /(^-?[0-9]+$)|^(-?[0-9]+.[0-9]+)$/;
    if ("" == txt.trim()) {
        $(obj).val("");
        return false;
    }
    if (!regExp.test(txt)) {
        $(obj).addClass("wrongShow");
        layer.alert(lan('Promt_OnlyNumber'), { title: [lan('Title'), true], btn: [lan('OK')] });
        return true;
    }
    return false;
}
// 不支持小数

function onlyInteger(obj) {
    $(obj).removeClass("wrongShow");
    var txt = $(obj).val();
    var regExp = /^-?[0-9]\d*$/; /*/^[0-9]+$/*/
    if ("" == txt.trim()) {
        $(obj).val("");
        return false;
    }
    if (!regExp.test(txt)) {
        $(obj).addClass("wrongShow");
        layer.alert(lan('Promt_OnlyInt'), { title: [lan('Title'), true], btn: [lan('OK')] });
        return true;
    }
    return false;
}

//检测URL
function checkURL(obj) {
    $(obj).removeClass("wrongShow");
    var txt = $(obj).val();
    var strRegex = "^((https|http|ftp|rtsp|mms)?://)" +
        "?(([0-9a-z_!~*'().&=+$%-]+: )?[0-9a-z_!~*'().&=+$%-]+@)?" // ftp的user@
        +
        "(([0-9]{1,3}.){3}[0-9]{1,3}" // IP形式的URL- 199.194.52.184
        +
        "|" // 允许IP和DOMAIN（域名）
        +
        "([0-9a-z_!~*'()-]+.)*" // 域名- www.
        +
        "([0-9a-z][0-9a-z-]{0,61})?[0-9a-z]." // 二级域名
        +
        "[a-z]{2,6})" // first level domain- .com or .museum
        +
        "(:[0-9]{1,4})?" // 端口- :80
        +
        "((/?)|" // a slash isn't required if there is no file name
        +
        "(/[0-9a-z_!~*'().;?:@&=+$,%#-]+)+/?)$";
    var regExp = new RegExp(strRegex);
    if ("" == txt.trim()) {
        $(obj).val("");
        return false;
    }
    if (!regExp.test(txt)) {
        $(obj).addClass("wrongShow");
        layer.alert(lan('Promt_URLError'), { title: [lan('Title'), true], btn: [lan('OK')] });
        return true;
    }
    return false;
}

//检测公司网址
function checkCompanyURL(obj) {
    $(obj).removeClass("wrongShow");
    var txt = $(obj).val();
    var strRegex = "^((https|http|ftp|rtsp|mms)?://)?[A-Za-z0-9-_]+\\.[A-Za-z0-9-_%&\?\/.=]+$";
    var regExp = new RegExp(strRegex);
    if ("" == txt.trim()) {
        $(obj).val("");
        return false;
    }
    if (!regExp.test(txt)) {
        $(obj).addClass("wrongShow");
        layer.alert(lan('Promt_URLError'), { title: [lan('Title'), true], btn: [lan('OK')] });
        return true;
    }
    return false;
}

//LayerOpen
layer.config({
    type: 0,
    icon: 0,
    skin: 'layui-layer-cust',
    closeBtn: 1,
    offset: 'auto',
    // area: ['500px', '300px'],
    // time: 10000,
    // extend: 'extend/layer.ext.js',
});

function layerInfoOpen(layer_title, layer_content, layer_btn, func, layer_type, layer_icon, layer_closeBtn, layer_time) {
    if (layer_title == null) {
        layer_title = lan('Message');
    }
    if (layer_content == null) {
        layer_content = lan('NoContent');
    }
    if (layer_btn == null) {
        layer_btn = lan('OK');
    }

    if (layer_type == null) {
        layer_type = 0;
    }
    if (layer_icon == null) {
        layer_icon = 0;
    }
    if (layer_closeBtn == null) {
        layer_closeBtn = 1;
    }
    if (layer_time == null) {
        layer_time = 0;
    }

    layer.closeAll();

    //icon: 默认皮肤可以传入0-6如果是加载层，可以传入0-2
    //0: 注意, 1: 正确, 2: 错误, 3:疑问, 4:锁定, 5: 哭脸, 6: 笑脸
    //type: 0（信息框，默认）1（页面层）2（iframe层）3（加载层）4（tips层）

    var index = layer.open({
        type: layer_type,
        icon: layer_icon,
        closeBtn: layer_closeBtn,
        title: layer_title,
        content: layer_content,
        btn: layer_btn,
        time: layer_time,
        resize: false,
        yes: function(index, layero) {
            layer.closeAll();
            if (func != null) {
                func();
            }
        },
        // cancel: function name(index, layero) {
        //     layer.close(index);
        // }
    });
    return index;
}

function layerTimeOpen(layer_title, layer_content, layer_btn, layer_type, layer_icon, layer_closeBtn, layer_time) {
    var index = layer.open({
        'offset': ["15%", "35%"],
        'time': layer_time || 2000,
        'type': layer_type || 0,
        'icon': layer_icon || 0,
        'closeBtn': layer_closeBtn || 0,
        'title': layer_title || "Message",
        'content': layer_content || "Error, No Message",
        'btn': layer_btn || lan('OK'),
        yes: function(index, layero) { layer.close(index) },
    });
    return index;
}

function layerLoadOpen(title, content) {
    // layer.closeAll();

    var indexopen = layer.open({
        icon: 4,
        closeBtn: 0,
        offset: '100px',
        title: title,
        content: content,
        btn: '',
    });

    var indexload = layer.load(1, { shade: [0.3, '#000'] });

    var index = {
        'indexopen': indexopen,
        'indexload': indexload,
    }

    return index;
}

function layerTipsOpen(content, id, tips, time) {
    // 支持上右下左四个方向，通过1-4进行方向设定

    if (content == null) {
        content = "Error, No Message";
    }
    if (id == null) {
        id = '';
    }
    if (tips == null) {
        tips = 1;
    }
    if (time == null) {
        time = 1500;
    }

    var index = layer.tips(content, "#" + id, {
        tips: [tips, '#008B8B'],
        time: time,
    });

    return index;
}

function layerPromptOpen(title, formType, value, func) {
    if (title == null) {
        title = "Message";
    }
    if (formType == null) {
        formType = 0;
    }
    if (value == null) {
        value = '';
    }

    //formType: 输入框类型，支持0（文本）默认1（密码）2（多行文本）
    //value: 初始时的值，默认空字符
    //maxlength: 可输入文本的最大长度，默认500
    var index = layer.prompt({
        formType: formType,
        value: value,
        title: title,
        maxlength: 140,
    }, function(value, index, elem) {
        func();
        layer.closeAll();
    });

    return index;
}